#define F_CPU 16000000
#include <stdio.h>
#include <stdlib.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>

#include "lcd.h"
void butoane_init()
{
	/* left */
	/* set input buttons */
	DDRC &= ~((1 << PC0)
		| (1 << PC1)
		| (1 << PC2)
		| (1 << PC3)
		| (1 << PC4));

	/* pull-up*/
	PORTC |= ((1 << PC0)
		  | (1 << PC1)
		  | (1 << PC2)
		  | (1 << PC3)
		  | (1 << PC4));

	/* right */
	/* set input buttons */
	DDRD &= ~((1 << PD0)
		| (1 << PD1)
		| (1 << PD2)
		| (1 << PD3)
		| (1 << PD4));

	/* pull-up*/
	PORTD |= ((1 << PD0)
		| (1 << PD1)
		| (1 << PD2)
		| (1 << PD3)
		| (1 << PD4));
}

/* first screen */
void init_game()
{
	lcd_goto_xy(0, 0);
	lcd_str("Press any");
	lcd_goto_xy(0, 1);
	lcd_str("middle button");
	lcd_goto_xy(0,2);
	lcd_str("to start");
}

/* last screen */
void end_game()
{
	lcd_goto_xy(1, 4);
	lcd_str("THE END");
}


void draw_pacman(int x, int y)
{
	lcd_goto_xy(x, y);
	lcd_chr(PACMAN);
}

void draw_enemy(int x, int y)
{
	lcd_goto_xy(x, y);
	lcd_chr(ENEMY);
}


int main()
{
	int pac_x, pac_y, enemy_x, enemy_y;
	int lives = 3;
	/* init butoane*/
	butoane_init();

	/* LCD init */
	lcd_init();
	lcd_contrast(0x40);

	/* Display first screen */
	init_game();

	/* wait for start */
	while (1) {
		if (((PINC & (1 << PC2)) == 0)
			|| ((PINC & (1 << PA2)) == 0))
			break;
		_delay_ms(50);
	}
	/* initial position */
	pac_x = 4;
	pac_y = 2;
	draw_pacman(4, 2);
	enemy_x = 1;
	enemy_y = 4;
	draw_enemy(1, 4);

	while (1) {
		lcd_clear();
		if (pac_x == enemy_x && pac_y == enemy_y)
			lives--;
		if (lives == 0) {
			end_game();
			break;
		}
		draw_pacman(pac_x, pac_y);
		draw_enemy(enemy_x, enemy_y);
		/* pacman move */
		/* UP */
		if ((PINC & (1 << PC0)) == 0)
			pac_x += 1;
		/* DOWN*/
		else if ((PINC & ( 1 << PC2)) == 0)
			pac_x -= 1;
		/* LEFT*/
		else if ((PINC & ( 1<< PC1)) == 0)
			pac_y += 1;
		/* RIGHT */
		else if ((PINC & (1 << PC3)) == 0)
			pac_y -= 1;

		/* enemy move */
		if ((PIND & (1 << PD0)) == 0)
			enemy_x += 1;
		/* DOWN*/
		else if ((PIND & ( 1 << PD2)) == 0)
			enemy_x -= 1;
		/* LEFT*/
		else if ((PIND & ( 1<< PD1)) == 0)
			enemy_y += 1;
		/* RIGHT */
		else if ((PIND & (1 << PD3)) == 0)
			enemy_y -= 1;

	}
	return 0;
}

